//
//  RootViewController.m
//  SampleOekaki
//

#import "RootViewController.h"
#import "DetailViewController.h"

@implementation RootViewController

@synthesize detailViewController;

#pragma mark -
#pragma mark View lifecycle

- (void)viewDidLoad {
    [super viewDidLoad];
    self.clearsSelectionOnViewWillAppear = NO;
    self.contentSizeForViewInPopover = CGSizeMake(320.0, 600.0);
    
    self.title = @"Color Palette";
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

#pragma mark -
#pragma mark Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)aTableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)aTableView numberOfRowsInSection:(NSInteger)section {
    return 4;
}

#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)viewDidUnload {
}

- (void)dealloc {
    [detailViewController release];
    [super dealloc];
}

// セルを生成する時
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {    
    static NSString *CellIdentifier = @"CellIdentifier";    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault 
                                       reuseIdentifier:CellIdentifier] autorelease];
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    
    // 行選択時にハイライト表示しないよう設定(見やすくするため)
	cell.selectionStyle = UITableViewCellSelectionStyleNone;
	
	return cell;
}

// セルが選択された時
- (void)tableView :(UITableView *)aTableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {    
    // 線の色を「黒」にセット
    if (indexPath.row == 0) {
        detailViewController.red = 0.0;
	detailViewController.green = 0.0;
	detailViewController.blue = 0.0;
    }
    // 線の色を「赤」にセット
    else if (indexPath.row == 1) {
	detailViewController.red = 1.0;
	detailViewController.green = 0.0;
	detailViewController.blue = 0.0;
    }
    // 線の色を「緑」にセット
    else if (indexPath.row == 2) {
	detailViewController.red = 0.0;
	detailViewController.green = 1.0;
	detailViewController.blue = 0.0;
    }
    // 線の色を「青」にセット
    else if (indexPath.row == 3) {
	detailViewController.red = 1.0;
	detailViewController.green = 1.0;
	detailViewController.blue = 1.0;
    }
    // セル選択時にチェックマークを表示する
    UITableViewCell *cell = [aTableView cellForRowAtIndexPath:indexPath];
    cell.accessoryType = UITableViewCellAccessoryCheckmark;
}

// セルの選択が解除された時
- (void)tableView:(UITableView *)aTableView didDeselectRowAtIndexPath:(NSIndexPath *)indexPath {    
    // セル未選択時にチェックマークを非表示にする
    UITableViewCell *cell = [aTableView cellForRowAtIndexPath:indexPath];
    cell.accessoryType = UITableViewCellAccessoryNone;
}

// セルが表示された時
- (void)tableView:(UITableView *)tableView willDisplayCell:(UITableViewCell *)cell 
                                         forRowAtIndexPath:(NSIndexPath *)indexPath {
    // セルの背景色を「黒」にセット
    if (indexPath.row == 0) {
        cell.backgroundColor = [UIColor blackColor];
    }
    // セルの背景色を「赤」にセット
    else if (indexPath.row == 1) {
        cell.backgroundColor = [UIColor redColor];
    }
    // セルの背景色を「緑」にセット
    else if (indexPath.row == 2) {
        cell.backgroundColor = [UIColor greenColor];
    }
    // セルの背景色を「青」にセット
    else if (indexPath.row == 3) {
        cell.backgroundColor = [UIColor blueColor];
    }
}

@end